searchNodes=[{"ref":"Mix.Tasks.Yacto.html","title":"Mix.Tasks.Yacto","type":"task","doc":"Prints Yacto tasks and their information. mix yacto"},{"ref":"Mix.Tasks.Yacto.Gen.Migration.html","title":"Mix.Tasks.Yacto.Gen.Migration","type":"task","doc":""},{"ref":"Mix.Tasks.Yacto.Gen.Migration.html#run/1","title":"Mix.Tasks.Yacto.Gen.Migration.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Yacto.Migrate.html","title":"Mix.Tasks.Yacto.Migrate","type":"task","doc":""},{"ref":"Mix.Tasks.Yacto.Migrate.html#run/1","title":"Mix.Tasks.Yacto.Migrate.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Yacto.html","title":"Yacto","type":"module","doc":"Yacto Yacto は、Ecto で手が届きにくい部分をサポートするためのライブラリです。 大まかに以下の機能があります。 マイグレーションファイルの自動生成 別アプリケーションからのマイグレーションの利用 水平分割したデータベースへのマイグレーション 複数データベースを跨るトランザクション（XA トランザクション） マイグレーションファイルの自動生成 Yacto は、特にマイグレーション周りが Ecto と異なります。 Ecto はスキーマとマイグレーションを別で定義していましたが、Yacto は スキーマからマイグレーションファイルを自動的に出力します。 具体的には、以下の様にスキーマを定義したとして、 lib/my_app/player.ex: defmodule MyApp.Player do use Yacto.Schema, dbname: :player schema @auto_source do # sharding key field :player_id, :string, meta: [null: false, size: 64] field :hp, :integer, default: 0, meta: [null: false] index :player_id, unique: true end end この状態で mix yacto.gen.migration を実行すると、以下の様なマイグレーションファイルが出力されます。 priv/migrations/2017-11-22T045225_my_app.exs: defmodule MyApp.Migration20171122045225 do use Ecto.Migration def change(MyApp.Player) do create table(&quot;my_app_player&quot;) alter table(&quot;my_app_player&quot;) do add(:hp, :integer, [null: false, size: 64]) add(:player_id, :string, [null: false]) end create index(&quot;my_app_player&quot;, [:player_id], [name: &quot;player_id_index&quot;, unique: true]) end def change(_other) do :ok end def __migration_structures__() do [ {MyApp.Player, %Yacto.Migration.Structure{fields: [:id, :player_id, :hp], meta: %{attrs: %{hp: %{null: false}, player_id: %{null: false, size: 64}}, indices: %{{[:player_id], [unique: true]} =&gt; true}}, source: &quot;my_app_player&quot;, types: %{hp: :integer, id: :id, player_id: :string}}}, ] end def __migration_version__() do 20171122045225 end end あとは mix yacto.migrate を実行すれば、このマイグレーションファイルがデータベースに反映されます。 もうマイグレーションファイルを自分で記述する必要はありません。 更に、この状態で MyApp.Player スキーマに :mp フィールドを追加して mix yacto.gen.migration を実行すると、以下のマイグレーションファイルが生成されます。 lib/my_app/player.ex: defmodule MyApp.Player do ... schema @auto_source do ... # add a field field :mp, :integer, default: 0, meta: [null: false] ... end end priv/migrations/2017-11-22T045225_my_app.exs: defmodule MyApp.Migration20171122052212 do use Ecto.Migration def change(MyApp.Player) do alter table(&quot;my_app_player&quot;) do add(:mp, :integer, [null: false]) end end def change(_other) do :ok end def __migration_structures__() do [ {MyApp.Player, %Yacto.Migration.Structure{fields: [:id, :player_id, :hp, :mp], meta: %{attrs: %{hp: %{null: false}, mp: %{null: false}, player_id: %{null: false, size: 64}}, indices: %{{[:player_id], [unique: true]} =&gt; true}}, source: &quot;my_app_player&quot;, types: %{hp: :integer, id: :id, mp: :integer, player_id: :string}}}, ] end def __migration_version__() do 20171122052212 end end このように、以前からの差分だけがマイグレーションファイルに出力されます。 mix yacto.migrate を実行すれば、このマイグレーションファイルがデータベースに反映されます。 もしマイグレーションファイルが１つもデータベースに適用されていなかったら、上記の２つのマイグレーションファイルが順番に適用されます。 別アプリケーションからのマイグレーションの利用 先程作った my_app アプリケーションを利用する other_app アプリケーションがあったとします。 my_app はデータベース利用しているので、other_app 上で my_app のためのマイグレーションを行う必要があります。 Yacto を使えば、config/config.exs を適切に書いた後、other_app で以下のコマンドを実行するだけで my_app のマイグレーションができます。 mix yacto.migrate --app my_app Ecto では、他のアプリケーションが必要としているマイグレーションを自分で書くか、各アプリケーションが指定したバラバラな方法でマイグレーションを行う必要がありました。 Yacto を使っているアプリケーションでは、全て同じ方法でマイグレーションができます。 水平分割したデータベースへのマイグレーション 例えば MyApp.Player スキーマを水平分割した場合、このスキーマのマイグレーションファイルを複数の Repo に適用する必要があります。 これは、設定ファイルに以下の様に書くだけで出来ます。 config/config.exs: config :yacto, :databases, %{ default: %{ module: Yacto.DB.Single, repo: MyApp.Repo.Default, }, player: %{ module: Yacto.DB.Shard, repos: [MyApp.Repo.Player0, MyApp.Repo.Player1], }, } MyApp.Player に以下のコードがあったことを思い出して下さい。 lib/my_app/player.ex: defmodule MyApp.Player do use Yacto.Schema, dbname: :player ... この :player が、MyApp.Player が所属する Repo のグループ名です。 MyApp.Player は :player という Repo グループに所属しており、:player Repo グループは設定ファイルから MyApp.Repo.Player0 と MyApp.Repo.Player1 の Repo に紐付いていることが分かります。 設定ファイルを書いたら、あとは mix yacto.migrate を実行するだけです。 MyApp.Player のマイグレーションファイルが MyApp.Repo.Player0 と MyApp.Repo.Player1 に適用されます。 水平分割したデータベースを利用する時には、Yacto.DB.repo/2 を使って Repo を取得します。 repo = Yacto.DB.repo(:player, player_id) MyApp.Player |&gt; repo.all() あるいは、schema.repo/1 を使っても構いません。 repo = MyApp.Player.repo(player_id) MyApp.Player |&gt; repo.all() 他のアプリケーションから利用する もちろん、この水平分割した my_app アプリケーションを other_app で利用することもできます。 other_app で以下の様に設定ファイル書いて、 config/config.exs: config :yacto, :databases, %{ default: %{ module: Yacto.DB.Single, repo: OtherApp.Repo.Default, }, player: %{ module: Yacto.DB.Shard, repos: [OtherApp.Repo.Player0, OtherApp.Repo.Player1, OtherApp.Repo.Player2], }, } mix yacto.migrate --app my_app を実行すると、OtherApp.Repo.Player0 と OtherApp.Repo.Player1 と OtherApp.Repo.Player2 に MyApp.Player スキーマのマイグレーションファイルが適用されます。 複数データベースを跨るトランザクション（XA トランザクション） Yacto.transaction/2 を使うと、複数のデータベースを指定してトランザクションを発行できます。 # ２つ以上の Repo が指定されているので XA トランザクションを発行する Yacto.transaction([:default, {:player, player_id1}, {:player, player_id2}], fn -&gt; default_repo = Yacto.DB.repo(:default) player1_repo = Yacto.DB.repo(:player, player_id1) player2_repo = Yacto.DB.repo(:player, player_id2) # ここら辺でデータベースを操作する ... # ここで全ての XA トランザクションがコミットされる end) 以下の３つの Repo に対してトランザクションを行います。 :default の Repo MyApp.Repo.Default player_id1 でシャーディングされた Repo player_id2 でシャーディングされた Repo 後ろの２つは、シャードキーによっては同じ Repo になる可能性があるので、利用する Repo は２つか３つのどちらかです。 ２つ以上の Repo を利用してトランザクションを開始する場合、自動的に XA トランザクションになります。 XA トランザクションは確実に不整合が防げる訳ではありませんが、別々でトランザクションを発行するよりは防げます。 ただしこのライブラリでは XA RECOVER に残ったトランザクションを解決する仕組みを提供していないので、別途用意する必要があります。 Yacto のスキーマ Yacto のスキーマについて、まだ説明していない部分があるので、もう少し詳しく説明します。 最初に書いたように、Yacto のスキーマは以下の様に定義します。 defmodule MyApp.Player do use Yacto.Schema, dbname: :player schema @auto_source do field :player_id, :string, meta: [null: false, size: 64] field :hp, :integer, default: 0, meta: [null: false] index :player_id, unique: true end end 基本的には Ecto.Schema と変わりません。 Yacto.Schema で生成したスキーマは、Ecto.Schema で生成したスキーマと互換性があります。 ただしマイグレーションに関する設定が含まれるので、Ecto.Schema よりもいくつか設定が増えています。 テーブル名の自動生成 @auto_source には、モジュール名から自動的に生成したテーブル名が定義されています。 大抵の場合、自動的に決まった名前で問題ないと思うので、常に @auto_source を使うので問題ないでしょう。 メタ情報 field :player_id, :string, meta: [null: false, size: 64] field :hp, :integer, default: 0, meta: [null: false] field :height, :decimal, meta: [precision: 10, scale: 3] ここは Ecto.Schema の field/3 関数とほとんど同じですが、:meta オプションがあるという点で異なります。 :meta オプションはマイグレーションに関する情報を入れる場所で、そのフィールドが null 可能かどうかや、文字列のサイズ等を指定します。 指定可能なオプションは以下の通りです。 :null: そのフィールドが null 可能かどうか（デフォルトでは true） :size: 文字列のサイズ（VARCHAR(255) の 255 に相当する部分）（デフォルトでは 255） :default: そのフィールドのデフォルト値（デフォルトでは各型の初期値か、opts[:default] が存在している場合はその値が入る） :precision: field/3 に渡す型が :decimal の場合の最大桁数を指定する（デフォルト値は利用する DB の仕様に従う） :scale: field/3 に渡す型が :decimal の場合の小数部の桁数を指定する（デフォルト値は利用する DB の仕様に従う） :index: このフィールドでインデックスを張るかどうか（デフォルトでは false） :type: マイグレーション時の型を指定する（デフォルトでは field/3 で指定した型） インデックス index :player_id, unique: true index/2 でインデックスを生成できます。 field/3 の :meta オプションの中でもインデックスを指定できますが、index/2 を使うと複合インデックスやユニークインデックスも生成できます。 複合インデックスにするなら index [:player_id, :hp] のようにリストで指定します。 ユニークインデックスにするならオプションで unique: true を指定します。 外部キー制約 対応していません。 必要だと思ったのであれば、ぜひ実装して pull req 下さい。 便利関数 Yacto は、Repo に便利な関数を定義する Yacto.Repo.Helper を提供しています。 defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app use Yacto.Repo.Helper end これによって、以下の関数が定義されます。 def count(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで要素数を返します。 def find(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで Repo から取得します。 def delete_by(queryable, clauses, opts \\\\ []) def delete_by!(queryable, clauses, opts \\\\ []) Ecto.Query.where で絞り込んで Repo から削除します。 delete_by!/3 は、削除した件数が 0 だった時に Ecto.NoResultsError 例外を投げます。 def find_for_update(queryable, clauses, opts \\\\ []) get_for_update(queryable, id, opts \\\\ []) get_for_update!(queryable, id, opts \\\\ []) get_by_for_update(queryable, clauses, opts \\\\ []) get_by_for_update!(queryable, clauses, opts \\\\ []) SELECT ... FOR UPDATE のクエリを使って要素を取得する関数です。 find_for_update/3 は find/3 のクエリに Ecto.Query.lock(&quot;FOR UPDATE&quot;) を付けただけの関数です。 get_for_update/3 や get_by_for_update/3 関数は、Ecto.Repo.get や Ecto.Repo.get_by のクエリに Ecto.Query.lock(&quot;FOR UPDATE&quot;) を付けただけの関数です。 get_by_or_new(queryable, clauses, default_struct, opts \\\\ []) get_by_or_insert_for_update(queryable, clauses, default_struct_or_changeset, opts \\\\ []) get_by_or_new/4 は、まずレコードを取得してみて、あればそのレコードを、無ければデフォルト値 default_struct を返します。無かった場合でもデータベースへの挿入は行いません。 ロックを取らないので、この get_by_or_new/4 で得られた値を使ってデータベースへ挿入や更新をしてはいけません。 戻り値は {record, defaulted} の２要素のタプルになっていて、1要素目には取得できたレコード（あるいはデフォルト値）が、2要素目にはデフォルト値を返したかどうかのフラグが設定されます。 get_by_or_insert_for_update/4 は、get_by_or_new/4 の排他ロックを取るバージョンです。 まずレコードを取得してみて、あればそのレコードを、無ければ新規に default_struct_or_changeset を挿入して返します。この時、返されるレコードは排他ロックされます。 戻り値は {record, created} の２要素のタプルになっていて、1要素目には取得できたレコード（あるいは挿入したデフォルト値）が、2要素目には新しく挿入したかどうかのフラグが設定されます。"},{"ref":"Yacto.html#transaction/3","title":"Yacto.transaction/3","type":"function","doc":""},{"ref":"Yacto.DB.html","title":"Yacto.DB","type":"behaviour","doc":"Yacto の repo を取得するためのモジュール 水平分割をしている場合、シャーディングキーによって利用する repo が変わるため、 直接 repo を利用するのではなく、Yacto.repo/{1-2} を利用する必要がある。"},{"ref":"Yacto.DB.html#all_repos/0","title":"Yacto.DB.all_repos/0","type":"function","doc":""},{"ref":"Yacto.DB.html#repo/2","title":"Yacto.DB.repo/2","type":"function","doc":""},{"ref":"Yacto.DB.html#c:repo/2","title":"Yacto.DB.repo/2","type":"callback","doc":""},{"ref":"Yacto.DB.html#repos/1","title":"Yacto.DB.repos/1","type":"function","doc":""},{"ref":"Yacto.DB.html#c:repos/1","title":"Yacto.DB.repos/1","type":"callback","doc":""},{"ref":"Yacto.DB.Shard.html","title":"Yacto.DB.Shard","type":"module","doc":""},{"ref":"Yacto.DB.Single.html","title":"Yacto.DB.Single","type":"module","doc":""},{"ref":"Yacto.Migration.GenMigration.html","title":"Yacto.Migration.GenMigration","type":"module","doc":""},{"ref":"Yacto.Migration.GenMigration.html#generate_fields/4","title":"Yacto.Migration.GenMigration.generate_fields/4","type":"function","doc":""},{"ref":"Yacto.Migration.GenMigration.html#generate_indices/3","title":"Yacto.Migration.GenMigration.generate_indices/3","type":"function","doc":""},{"ref":"Yacto.Migration.GenMigration.html#generate_migration/6","title":"Yacto.Migration.GenMigration.generate_migration/6","type":"function","doc":"マイグレーションファイルを生成する app: 対象のアプリケーション schemas: このアプリケーションに存在するスキーマの一覧 delete_schemas: このアプリケーションから削除されたスキーマの一覧 migration_version: 生成するマイグレーションファイルのバージョン。nil の場合はタイムスタンプから自動生成される。 migration_dir: マイグレーションファイルを出力するディレクトリ opts: オプション :index_name_max_length: インデックス名の最大長。 自動的に生成されたインデックス名がこの長さを超えてしまう場合、ハッシュ化した名前に変換される。 :infinity の場合、決してハッシュ化を行わない。デフォルトは :infinity。"},{"ref":"Yacto.Migration.GenMigration.html#generate_source/5","title":"Yacto.Migration.GenMigration.generate_source/5","type":"function","doc":""},{"ref":"Yacto.Migration.GenMigration.html#get_latest_migration/1","title":"Yacto.Migration.GenMigration.get_latest_migration/1","type":"function","doc":"最新のマイグレーションモジュールを取得する マイグレーションモジュールが１件も存在しなかった場合は nil を返す。"},{"ref":"Yacto.Migration.Migrator.html","title":"Yacto.Migration.Migrator","type":"module","doc":""},{"ref":"Yacto.Migration.Migrator.html#migrated_versions/3","title":"Yacto.Migration.Migrator.migrated_versions/3","type":"function","doc":""},{"ref":"Yacto.Migration.Migrator.html#up/5","title":"Yacto.Migration.Migrator.up/5","type":"function","doc":"Runs an up migration on the given repository. Options :log - the level to use for logging of migration instructions. Defaults to :info. Can be any of Logger.level/0 values or a boolean. :log_sql - the level to use for logging of SQL instructions. Defaults to false. Can be any of Logger.level/0 values or a boolean. :prefix - the prefix to run the migrations on :dynamic_repo - the name of the Repo supervisor process. See Ecto.Repo.put_dynamic_repo/1. :strict_version_order - abort when applying a migration with old timestamp"},{"ref":"Yacto.Migration.SchemaMigration.html","title":"Yacto.Migration.SchemaMigration","type":"module","doc":""},{"ref":"Yacto.Migration.SchemaMigration.html#down/4","title":"Yacto.Migration.SchemaMigration.down/4","type":"function","doc":""},{"ref":"Yacto.Migration.SchemaMigration.html#ensure_schema_migrations_table!/1","title":"Yacto.Migration.SchemaMigration.ensure_schema_migrations_table!/1","type":"function","doc":""},{"ref":"Yacto.Migration.SchemaMigration.html#migrated_versions/3","title":"Yacto.Migration.SchemaMigration.migrated_versions/3","type":"function","doc":""},{"ref":"Yacto.Migration.SchemaMigration.html#up/4","title":"Yacto.Migration.SchemaMigration.up/4","type":"function","doc":""},{"ref":"Yacto.Migration.Structure.html","title":"Yacto.Migration.Structure","type":"module","doc":""},{"ref":"Yacto.Migration.Structure.html#apply/2","title":"Yacto.Migration.Structure.apply/2","type":"function","doc":""},{"ref":"Yacto.Migration.Structure.html#diff/2","title":"Yacto.Migration.Structure.diff/2","type":"function","doc":""},{"ref":"Yacto.Migration.Structure.html#from_schema/1","title":"Yacto.Migration.Structure.from_schema/1","type":"function","doc":""},{"ref":"Yacto.Migration.Structure.html#to_string/1","title":"Yacto.Migration.Structure.to_string/1","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html","title":"Yacto.Migration.Util","type":"module","doc":""},{"ref":"Yacto.Migration.Util.html#allow_migrate?/2","title":"Yacto.Migration.Util.allow_migrate?/2","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#apply_myers_difference/2","title":"Yacto.Migration.Util.apply_myers_difference/2","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#get_all_schema/2","title":"Yacto.Migration.Util.get_all_schema/2","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#get_migration_dir/2","title":"Yacto.Migration.Util.get_migration_dir/2","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#get_migration_dir_for_gen/1","title":"Yacto.Migration.Util.get_migration_dir_for_gen/1","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#get_migration_filename/2","title":"Yacto.Migration.Util.get_migration_filename/2","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#get_migration_files/2","title":"Yacto.Migration.Util.get_migration_files/2","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#get_migration_path/3","title":"Yacto.Migration.Util.get_migration_path/3","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#get_migration_path_for_gen/3","title":"Yacto.Migration.Util.get_migration_path_for_gen/3","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#is_migration_module?/1","title":"Yacto.Migration.Util.is_migration_module?/1","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#is_schema_module?/1","title":"Yacto.Migration.Util.is_schema_module?/1","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#load_migrations/1","title":"Yacto.Migration.Util.load_migrations/1","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#need_gen_migration?/1","title":"Yacto.Migration.Util.need_gen_migration?/1","type":"function","doc":""},{"ref":"Yacto.Migration.Util.html#sort_migrations/1","title":"Yacto.Migration.Util.sort_migrations/1","type":"function","doc":"マイグレーションファイルが正しく順序付けされているか調べて、正しい順序のマイグレーション情報を返す migrations には %{file: ファイル名, module: モジュール, version: マイグレーションバージョン, preview_version: 直前のマイグレーションバージョン} のリストを渡すこと。 旧マイグレーションファイルには直前のマイグレーションバージョンが存在しないが、その場合には :unspecified を指定すること。"},{"ref":"Yacto.Migration.Util.html#validate_version/1","title":"Yacto.Migration.Util.validate_version/1","type":"function","doc":""},{"ref":"Yacto.Query.html","title":"Yacto.Query","type":"module","doc":"クエリに関する便利関数を提供するモジュール"},{"ref":"Yacto.Query.html#for_update/1","title":"Yacto.Query.for_update/1","type":"function","doc":"SELECT ... FOR UPDATE のクエリを発行する"},{"ref":"Yacto.Repo.Helper.html","title":"Yacto.Repo.Helper","type":"module","doc":"repo のためのヘルパ関数 defmodule MyApp.Repo do use Ecto.Repo, otp_app: :my_app use Yacto.Repo.Helper end person = MyApp.Repo.get_or_insert_for_update(Person, [name: &quot;foo&quot;], %Person{name: &quot;foo&quot;, value: 10}) # これで person は排他ロックになる changeset = Person.changeset(person, [value: person.value + 5]) _person = MyApp.Repo.update!(changeset)"},{"ref":"Yacto.Schema.html","title":"Yacto.Schema","type":"behaviour","doc":"Yacto 用のスキーマ 以下のように利用する。 defmodule MyApp.Schema.Item do use Yacto.Schema, dbname: :default schema @auto_source do field :name, :string, meta: [null: false, size: 16, index: true] end end defmodule MyApp.Schema.Player do use Yacto.Schema, dbname: :player schema @auto_source do field :name, :string, meta: [null: false, size: 16, index: true] end end"},{"ref":"Yacto.Schema.html#c:dbname/0","title":"Yacto.Schema.dbname/0","type":"callback","doc":""},{"ref":"Yacto.Schema.html#field/3","title":"Yacto.Schema.field/3","type":"macro","doc":""},{"ref":"Yacto.Schema.html#index/2","title":"Yacto.Schema.index/2","type":"macro","doc":""},{"ref":"Yacto.Schema.html#schema/2","title":"Yacto.Schema.schema/2","type":"macro","doc":""},{"ref":"Yacto.Schema.html#timestamps/1","title":"Yacto.Schema.timestamps/1","type":"macro","doc":""},{"ref":"Yacto.Schema.Shard.html","title":"Yacto.Schema.Shard","type":"module","doc":"水平分割されたスキーマ Yacto.Schema とほぼ同じだが、Yacto.DB.repo(MySchema.dbname(), shard_key) のショートハンドとして MySchema.repo(shard_key) が使える点のみが異なる。"},{"ref":"Yacto.Schema.Single.html","title":"Yacto.Schema.Single","type":"module","doc":"通常の（水平分割されていない）スキーマ Yacto.Schema とほぼ同じだが、Yacto.DB.repo(MySchema.dbname()) のショートハンドとして MySchema.repo() が使える点のみが異なる。"},{"ref":"Yacto.XA.html","title":"Yacto.XA","type":"module","doc":"XA トランザクションを行うためのモジュール"},{"ref":"Yacto.XA.html#in_xa_transaction?/1","title":"Yacto.XA.in_xa_transaction?/1","type":"function","doc":""},{"ref":"Yacto.XA.html#rollback/2","title":"Yacto.XA.rollback/2","type":"function","doc":""},{"ref":"Yacto.XA.html#transaction/3","title":"Yacto.XA.transaction/3","type":"function","doc":""},{"ref":"Yacto.XA.html#with_xa/3","title":"Yacto.XA.with_xa/3","type":"function","doc":""},{"ref":"Yacto.XA.RepoState.html","title":"Yacto.XA.RepoState","type":"module","doc":""},{"ref":"Yacto.XA.RollbackError.html","title":"Yacto.XA.RollbackError","type":"exception","doc":""}]